#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass
from datetime import datetime
from gql.gql.datetime_utils import DATETIME_FIELD
from gql.gql.graphql_client import GraphqlClient
from gql.gql.client import OperationException
from gql.gql.reporter import FailedOperationException
from functools import partial
from numbers import Number
from typing import Any, Callable, List, Mapping, Optional, Dict
from time import perf_counter
from dataclasses_json import DataClassJsonMixin

from ..fragment.property import PropertyFragment, QUERY as PropertyFragmentQuery
from ..fragment.work_order import WorkOrderFragment, QUERY as WorkOrderFragmentQuery
from gql.gql.enum_utils import enum_field
from ..enum.project_priority import ProjectPriority

QUERY: List[str] = PropertyFragmentQuery + WorkOrderFragmentQuery + ["""
fragment ProjectFragment on Project {
    id
    name
    description
    priority
    createdBy{
        id
    }
    type{
        id
        name
    }
    location{
        id
    }
    workOrders {
        ...WorkOrderFragment
    }
    properties{
        ...PropertyFragment
    }
}
"""]

@dataclass
class ProjectFragment(DataClassJsonMixin):
    @dataclass
    class User(DataClassJsonMixin):
        id: str

    @dataclass
    class ProjectType(DataClassJsonMixin):
        id: str
        name: str

    @dataclass
    class Location(DataClassJsonMixin):
        id: str

    @dataclass
    class WorkOrder(WorkOrderFragment):
        pass

    @dataclass
    class Property(PropertyFragment):
        pass

    id: str
    name: str
    description: Optional[str]
    createdBy: Optional[User]
    type: ProjectType
    location: Optional[Location]
    workOrders: List[WorkOrder]
    properties: List[Property]
    priority: ProjectPriority = enum_field(ProjectPriority)
