#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass
from datetime import datetime
from gql.gql.datetime_utils import DATETIME_FIELD
from gql.gql.graphql_client import GraphqlClient
from gql.gql.client import OperationException
from gql.gql.reporter import FailedOperationException
from functools import partial
from numbers import Number
from typing import Any, Callable, List, Mapping, Optional, Dict
from time import perf_counter
from dataclasses_json import DataClassJsonMixin

from gql.gql.enum_utils import enum_field
from ..enum.image_entity import ImageEntity


QUERY: List[str] = ["""
mutation DeleteImageMutation(
  $entityType: ImageEntity!
  $entityId: ID!
  $id: ID!
) {
  deleteImage(entityType: $entityType, entityId: $entityId, id: $id) {
    id
    fileName
  }
}

"""]

@dataclass
class DeleteImageMutation(DataClassJsonMixin):
    @dataclass
    class DeleteImageMutationData(DataClassJsonMixin):
        @dataclass
        class File(DataClassJsonMixin):
            id: str
            fileName: str

        deleteImage: File

    data: DeleteImageMutationData

    @classmethod
    # fmt: off
    def execute(cls, client: GraphqlClient, entityType: ImageEntity, entityId: str, id: str) -> DeleteImageMutationData.File:
        # fmt: off
        variables: Dict[str, Any] = {"entityType": entityType, "entityId": entityId, "id": id}
        try:
            network_start = perf_counter()
            response_text = client.call(''.join(set(QUERY)), variables=variables)
            decode_start = perf_counter()
            res = cls.from_json(response_text).data
            decode_time = perf_counter() - decode_start
            network_time = decode_start - network_start
            client.reporter.log_successful_operation("DeleteImageMutation", variables, network_time, decode_time)
            return res.deleteImage
        except OperationException as e:
            raise FailedOperationException(
                client.reporter,
                e.err_msg,
                e.err_id,
                "DeleteImageMutation",
                variables,
            )
